- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- File List
- Globals

# unistr.h File Reference

C++ API: Unicode String. More...

`#include "unicode/rep.h"`

Go to the source code of this file.

## Data Structures
class | UnicodeString
| UnicodeString is a string class that stores Unicode characters directly and provides similar functionality as the Java String and StringBuffer classes. More...
## Defines
#define | U_COMPARE_CODE_POINT_ORDER 0x8000
| Option bit for u_strCaseCompare, u_strcasecmp, unorm_compare, etc: Compare strings in code point order instead of code unit order.
#define | US_INV U_NAMESPACE_QUALIFIER UnicodeString::kInvariant
| Constant to be used in the UnicodeString(char *, int32_t, EInvariant) constructor which constructs a Unicode string from an invariant-character char * string.
#define | UNICODE_STRING(cs, _length) U_NAMESPACE_QUALIFIER UnicodeString(TRUE, (const UChar *)L ## cs, _length)
| Unicode String literals in C++.
#define | UNICODE_STRING_SIMPLE(cs) UNICODE_STRING(cs, -1)
| Unicode String literals in C++.
## Functions
int32_t | u_strlen (const UChar *s)
| Determine the length of an array of UChar.
U_COMMON_API UnicodeString | operator+ (const UnicodeString &s1, const UnicodeString &s2)
| Create a new UnicodeString with the concatenation of two others.

## Detailed Description

C++ API: Unicode String.

Definition in file unistr.h.

## Define Documentation

#define U_COMPARE_CODE_POINT_ORDER 0x8000

Option bit for u_strCaseCompare, u_strcasecmp, unorm_compare, etc: Compare strings in code point order instead of code unit order.

Stable:
  ICU 2.2

Definition at line 41 of file unistr.h.

#define UNICODE_STRING | ( | cs,
|  | _length |  | ) | U_NAMESPACE_QUALIFIER UnicodeString(TRUE, (const UChar *)L ## cs, _length)

Unicode String literals in C++.

Dependent on the platform properties, different UnicodeString constructors should be used to create a UnicodeString object from a string literal. The macros are defined for maximum performance. They work only for strings that contain "invariant characters", i.e., only latin letters, digits, and some punctuation. See utypes.h for details.

The string parameter must be a C string literal. The length of the string, not including the terminating `NUL`, must be specified as a constant. The U_STRING_DECL macro should be invoked exactly once for one such string variable before it is used.

Stable:
  ICU 2.0

Definition at line 92 of file unistr.h.

#define UNICODE_STRING_SIMPLE | ( | cs |  | ) | UNICODE_STRING(cs, -1)

Unicode String literals in C++.

Dependent on the platform properties, different UnicodeString constructors should be used to create a UnicodeString object from a string literal. The macros are defined for improved performance. They work only for strings that contain "invariant characters", i.e., only latin letters, digits, and some punctuation. See utypes.h for details.

The string parameter must be a C string literal.

Stable:
  ICU 2.0

Definition at line 112 of file unistr.h.

#define US_INV U_NAMESPACE_QUALIFIER UnicodeString::kInvariant

Constant to be used in the UnicodeString(char *, int32_t, EInvariant) constructor which constructs a Unicode string from an invariant-character char * string.

About invariant characters see utypes.h. This constructor has no runtime dependency on conversion code and is therefore recommended over ones taking a charset name string (where the empty string "" indicates invariant-character conversion).

Stable:
  ICU 3.2

Definition at line 70 of file unistr.h.

## Function Documentation

U_COMMON_API UnicodeString operator+ | ( | const UnicodeString & | s1,
|  | const UnicodeString & | s2 |
| ) |  |  |

Create a new UnicodeString with the concatenation of two others.

Parameters:

  | s1 | The first string to be copied to the new one.
  | s2 | The second string to be copied to the new one, after s1.

Returns:
  UnicodeString(s1).append(s2)

Stable:
  ICU 2.8